package diamond_m

import (
	"hilo-user/_const/enum/diamond_e"
	"hilo-user/domain"
	"hilo-user/myerr/bizerr"
	"hilo-user/resource/mysql"
)

func CheckEnoughDiamondFrozen(model *domain.Model, userId mysql.ID, diamondNum mysql.Num) (*DiamondAccount, error) {
	diamondAccount, err := GetDiamondAccountByUserId(model, userId)
	if err != nil {
		return nil, err
	}
	if diamondAccount.DiamondNum < diamondNum {
		return nil, bizerr.DiamondNoEnough
	}
	if diamondAccount.Status == diamond_e.Frozen {
		return nil, bizerr.DiamondAccountFrozen
	}
	return diamondAccount, nil
}
